%% set inputs for solution below
%  The program produces responses to the shocks selected below under
%  irfshock. Paths for all the endogenous variables in the model selected
%  are produced. VariableName_difference holds the piece-wise linear solution for
%  VariableName.  VariableName_uncdifference holds the linear solution for
%  VariableName.

 set(0,'DefaultFigureWindowStyle' , 'docked')
 global M_ oo_

restoredefaultpath
rng(100)
% rng default
format compact

% dir1='/Applications/Dynare/4.3.1/matlab';
% dir2='/Users/pcubab/Dropbox/occbin_Estimation_web/occbin_20130531/toolkit_files';
 dir1='C:\Dropbox\E\occbin_Estimation_web\Dynare\4.3.1\matlab';
 dir2='C:\Dropbox\E\occbin_Estimation_web\occbin_20130531\toolkit_files';
path(dir1,path);
path(dir2,path);




% modname below chooses model
% directory. But simple param choices are made from paramfile_borrcon in current
% directory.
modnam = 'borrcon';
modnamstar = 'borrconnotbinding';

% Enter parameter values and save them in PARAM_EXTRA.mat file.
% This choices overwrite any choice that are made in the paramfile_borrcon file.
R = 1.05;
BETA = 0.945;
RHO   = 0.9;
STD_U = 0.03; %0.03*(1-RHO^2)^0.5;
M = 1;
GAMMAC = 1;
save PARAM_EXTRA R BETA RHO STD_U GAMMAC M




% see notes 1 and 2 in README. Note that 
% lb_ss is the steady-state value of the multiplier lb (see borrcon_steadystate.m).
%    lb_ss is calculated automatically as additional auxiliary parameter
%    around line 49 of solve_one_constraint
constraint = 'lb<-lb_ss';
constraint_relax ='b>M*y';

% Pick innovation for IRFs
irfshock =char('u');      % label for innovation for IRFs


  nperiods = 100;
  shockssequence=randn(nperiods,1)*STD_U;
 
% nperiods = 40;
% shockssequence=0*randn(nperiods,1);
% shockssequence(2)=0.03;
% shockssequence(21)=-0.03;
    
[zdatalinear zdatapiecewise zdatass oobase_ Mbase_  ] = ...
  solve_one_constraint(modnam,modnamstar,...
  constraint, constraint_relax,...
  shockssequence,irfshock,nperiods);



% unpack the IRFs
for i=1:Mbase_.endo_nbr
  eval([deblank(Mbase_.endo_names(i,:)),'_l=zdatalinear(:,i);']);
  eval([deblank(Mbase_.endo_names(i,:)),'_p=zdatapiecewise(:,i);']);
  eval([deblank(Mbase_.endo_names(i,:)),'_ss=zdatass(i);']);
%   eval([deblank(Mbase_.endo_names(i,:)),'_g=zdataglobal(:,i)-zdatass(i);']);
end
   

titlelist = char('y (income)','b (borrowing)','c (consumption)','lb (multiplier)','b/y','EC');
percent = 'Percent';
level = 'Level';
ylabels = char(level,level,level,level,level,level);
figtitle = 'Simulated variables';
legendlist = char('occbin','linear');


line1=[y_p+y_ss,b_p+b_ss,c_p+c_ss,(lb_p+lb_ss),(b_p+b_ss)./(y_p+y_ss),ec_p+ec_ss];
line2=[y_l+y_ss,b_l+b_ss,c_l+c_ss,(lb_l+lb_ss),(b_l+b_ss)./(y_l+y_ss),ec_l+ec_ss];



makechart(titlelist,legendlist,figtitle,ylabels,line1,line2);

